Subject: Re: e1000_down and tx_timeout worker race cleaning the transmit buffers

From: "Michael Chan" <[email-masked]>
Date: Thu, 20 Apr 2006 15:36:57 -0700

On Fri, 2006-04-21 at 09:51 +1000, Herbert Xu wrote:

> 
> Actually TG3 is buggy too.  If the reset task is scheduled but
> isn't running yet there is no synchronisation here to prevent the
> reset task from running after tg3_close releases the tp lock.
> 

If we're in tg3_close() and the reset task isn't running yet, tg3_close
() will proceed. However, when the reset task finally runs, it will see
that netif_running() is zero and will just return.